import { Agent as HttpAgent } from 'node:http';
import { Agent as HttpsAgent, AgentOptions } from 'node:https';
import { Agent as UndiciAgentType, ProxyAgent as UndiciProxyAgentType } from 'undici';

export type FetchEnhancedRequestInput = string | URL;
export type FetchEnhancedAgent = UndiciProxyAgentType | UndiciAgentType | HttpAgent | HttpsAgent;
export type FetchEnhancedAgentsOpts = AgentOptions & {
    noProxy?: boolean;
};
type ModuleOpts = {
    undici: boolean;
    agentCacheSize?: number;
};
export type FetchOpts = {
    timeout?: number;
    agent?: FetchEnhancedAgent;
    dispatcher?: FetchEnhancedAgent;
    agentOpts?: FetchEnhancedAgentsOpts;
} & RequestInit;
export declare class TimeoutError extends Error {
    constructor(message: string);
}
export default function fetchEnhanced(fetchImplementation: any, { undici, agentCacheSize }?: ModuleOpts): {
    (url: FetchEnhancedRequestInput, { timeout, agentOpts, ...opts }?: FetchOpts): Promise<Response>;
    clearCache(): void;
};
export {};
//# sourceMappingURL=index.d.ts.map